;9/3/02 - added #ifndef statements and such

;Ion datatype for YAS 2.0
;by Aaron Curtis and Jonah Cohen

#define ionhighc(x) $f400+x-ion_comment
#define ionhighi(x) $f400+x-ion_icon
#define ionhighd(x) $f400+x-ion_detect
#define ionrelptr(x) x-$-1			;relative pointer

	.db 1
	.db $0c							;detects strings
	.db "Ion"						;3 byte descripiton

	.dw ion_exec

	.dw ion_enddetect-ion_detect
	.dw ionrelptr(ion_detect)

	.dw ion_endcomment-ion_comment
	.dw ionrelptr(ion_comment)

	.dw ion_endicon-ion_icon
	.dw ionrelptr(ion_icon)


ion_detect:
	call _GET_DATA_SIZE_DE_INC	;skip past length bytes

	;** this was borrowed from the Ion86 source **
	call _GET_DATA_SIZE_DE_INC
	push hl
	ld hl,$8300
	call _cphlde
	pop hl
	scf
	ret nz
	call _GET_DATA_SIZE_DE_INC
	ld hl,$30C9
	call _cphlde
	ret z
	ld hl,$30AF
	call _cphlde
	ret z
	scf
	ret
ion_enddetect:


ion_exec:
	call _op1toop6
	ld hl,ionprog-1
	rst 20h
	rst 10h
	ret c
	set ex_asm_module,(iy+anumeditflgs)
	jp _exec_assembly

ionprog:
	.db 5,"Ion86",0


ion_comment:
#ifdef NOCOMMENT
	scf
	ret
#else
    ld de,5
	add hl,de
    ld d,$f5
    push de
ion_copyloop:
    bit 6,h
    jr z,ion_nonewpage
    res 6,h
    in a,(6)
    inc a
    out (6),a
ion_nonewpage:
    ld a,(hl)
    ldi
    or a
    jr nz,ion_copyloop
    pop hl
    ret
#endif
ion_endcomment:


ion_icon:
#ifdef NOICON
	scf	
	ret
#else
#ifdef ION_NODEFAULTICON
	scf
	ret
#else
    ld hl,ionhighi(ion_default_icon)
	ld bc,6+(256*1)
	or a
    ret

ion_default_icon:
	.db %11100110
	.db %01000101
	.db %01010101
	.db %11101101
	.db %00101000
	.db %00010000

#endif
#endif
ion_endicon:




.end
